use conjure_object::serde::{ser, de};
use conjure_object::serde::ser::SerializeMap as SerializeMap_;
use conjure_object::private::{UnionField_, UnionTypeField_};
use std::fmt;
#[derive(Debug, Clone, PartialEq, Eq, PartialOrd, Ord, Hash)]
pub enum CreateIntegrationDetails {
    CreateSimpleWebhookDetails(super::CreateSimpleWebhookDetails),
    CreateOpsgenieIntegrationDetails(super::CreateOpsgenieIntegrationDetails),
    CreateTeamsWebhookIntegrationDetails(super::CreateTeamsWebhookIntegrationDetails),
    CreatePagerDutyIntegrationDetails(super::CreatePagerDutyIntegrationDetails),
    /// An unknown variant.
    Unknown(Unknown),
}
impl ser::Serialize for CreateIntegrationDetails {
    fn serialize<S>(&self, s: S) -> Result<S::Ok, S::Error>
    where
        S: ser::Serializer,
    {
        let mut map = s.serialize_map(Some(2))?;
        match self {
            CreateIntegrationDetails::CreateSimpleWebhookDetails(value) => {
                map.serialize_entry(&"type", &"createSimpleWebhookDetails")?;
                map.serialize_entry(&"createSimpleWebhookDetails", value)?;
            }
            CreateIntegrationDetails::CreateOpsgenieIntegrationDetails(value) => {
                map.serialize_entry(&"type", &"createOpsgenieIntegrationDetails")?;
                map.serialize_entry(&"createOpsgenieIntegrationDetails", value)?;
            }
            CreateIntegrationDetails::CreateTeamsWebhookIntegrationDetails(value) => {
                map.serialize_entry(&"type", &"createTeamsWebhookIntegrationDetails")?;
                map.serialize_entry(&"createTeamsWebhookIntegrationDetails", value)?;
            }
            CreateIntegrationDetails::CreatePagerDutyIntegrationDetails(value) => {
                map.serialize_entry(&"type", &"createPagerDutyIntegrationDetails")?;
                map.serialize_entry(&"createPagerDutyIntegrationDetails", value)?;
            }
            CreateIntegrationDetails::Unknown(value) => {
                map.serialize_entry(&"type", &value.type_)?;
                map.serialize_entry(&value.type_, &value.value)?;
            }
        }
        map.end()
    }
}
impl<'de> de::Deserialize<'de> for CreateIntegrationDetails {
    fn deserialize<D>(d: D) -> Result<CreateIntegrationDetails, D::Error>
    where
        D: de::Deserializer<'de>,
    {
        d.deserialize_map(Visitor_)
    }
}
struct Visitor_;
impl<'de> de::Visitor<'de> for Visitor_ {
    type Value = CreateIntegrationDetails;
    fn expecting(&self, fmt: &mut fmt::Formatter) -> fmt::Result {
        fmt.write_str("union CreateIntegrationDetails")
    }
    fn visit_map<A>(self, mut map: A) -> Result<CreateIntegrationDetails, A::Error>
    where
        A: de::MapAccess<'de>,
    {
        let v = match map.next_key::<UnionField_<Variant_>>()? {
            Some(UnionField_::Type) => {
                let variant = map.next_value()?;
                let key = map.next_key()?;
                match (variant, key) {
                    (
                        Variant_::CreateSimpleWebhookDetails,
                        Some(Variant_::CreateSimpleWebhookDetails),
                    ) => {
                        let value = map.next_value()?;
                        CreateIntegrationDetails::CreateSimpleWebhookDetails(value)
                    }
                    (
                        Variant_::CreateOpsgenieIntegrationDetails,
                        Some(Variant_::CreateOpsgenieIntegrationDetails),
                    ) => {
                        let value = map.next_value()?;
                        CreateIntegrationDetails::CreateOpsgenieIntegrationDetails(value)
                    }
                    (
                        Variant_::CreateTeamsWebhookIntegrationDetails,
                        Some(Variant_::CreateTeamsWebhookIntegrationDetails),
                    ) => {
                        let value = map.next_value()?;
                        CreateIntegrationDetails::CreateTeamsWebhookIntegrationDetails(
                            value,
                        )
                    }
                    (
                        Variant_::CreatePagerDutyIntegrationDetails,
                        Some(Variant_::CreatePagerDutyIntegrationDetails),
                    ) => {
                        let value = map.next_value()?;
                        CreateIntegrationDetails::CreatePagerDutyIntegrationDetails(
                            value,
                        )
                    }
                    (Variant_::Unknown(type_), Some(Variant_::Unknown(b))) => {
                        if type_ == b {
                            let value = map.next_value()?;
                            CreateIntegrationDetails::Unknown(Unknown { type_, value })
                        } else {
                            return Err(
                                de::Error::invalid_value(de::Unexpected::Str(&type_), &&*b),
                            )
                        }
                    }
                    (variant, Some(key)) => {
                        return Err(
                            de::Error::invalid_value(
                                de::Unexpected::Str(key.as_str()),
                                &variant.as_str(),
                            ),
                        );
                    }
                    (variant, None) => {
                        return Err(de::Error::missing_field(variant.as_str()));
                    }
                }
            }
            Some(UnionField_::Value(variant)) => {
                let value = match &variant {
                    Variant_::CreateSimpleWebhookDetails => {
                        let value = map.next_value()?;
                        CreateIntegrationDetails::CreateSimpleWebhookDetails(value)
                    }
                    Variant_::CreateOpsgenieIntegrationDetails => {
                        let value = map.next_value()?;
                        CreateIntegrationDetails::CreateOpsgenieIntegrationDetails(value)
                    }
                    Variant_::CreateTeamsWebhookIntegrationDetails => {
                        let value = map.next_value()?;
                        CreateIntegrationDetails::CreateTeamsWebhookIntegrationDetails(
                            value,
                        )
                    }
                    Variant_::CreatePagerDutyIntegrationDetails => {
                        let value = map.next_value()?;
                        CreateIntegrationDetails::CreatePagerDutyIntegrationDetails(
                            value,
                        )
                    }
                    Variant_::Unknown(type_) => {
                        let value = map.next_value()?;
                        CreateIntegrationDetails::Unknown(Unknown {
                            type_: type_.clone(),
                            value,
                        })
                    }
                };
                if map.next_key::<UnionTypeField_>()?.is_none() {
                    return Err(de::Error::missing_field("type"));
                }
                let type_variant = map.next_value::<Variant_>()?;
                if variant != type_variant {
                    return Err(
                        de::Error::invalid_value(
                            de::Unexpected::Str(type_variant.as_str()),
                            &variant.as_str(),
                        ),
                    );
                }
                value
            }
            None => return Err(de::Error::missing_field("type")),
        };
        if map.next_key::<UnionField_<Variant_>>()?.is_some() {
            return Err(de::Error::invalid_length(3, &"type and value fields"));
        }
        Ok(v)
    }
}
#[derive(PartialEq)]
enum Variant_ {
    CreateSimpleWebhookDetails,
    CreateOpsgenieIntegrationDetails,
    CreateTeamsWebhookIntegrationDetails,
    CreatePagerDutyIntegrationDetails,
    Unknown(Box<str>),
}
impl Variant_ {
    fn as_str(&self) -> &'static str {
        match *self {
            Variant_::CreateSimpleWebhookDetails => "createSimpleWebhookDetails",
            Variant_::CreateOpsgenieIntegrationDetails => {
                "createOpsgenieIntegrationDetails"
            }
            Variant_::CreateTeamsWebhookIntegrationDetails => {
                "createTeamsWebhookIntegrationDetails"
            }
            Variant_::CreatePagerDutyIntegrationDetails => {
                "createPagerDutyIntegrationDetails"
            }
            Variant_::Unknown(_) => "unknown variant",
        }
    }
}
impl<'de> de::Deserialize<'de> for Variant_ {
    fn deserialize<D>(d: D) -> Result<Variant_, D::Error>
    where
        D: de::Deserializer<'de>,
    {
        d.deserialize_str(VariantVisitor_)
    }
}
struct VariantVisitor_;
impl<'de> de::Visitor<'de> for VariantVisitor_ {
    type Value = Variant_;
    fn expecting(&self, fmt: &mut fmt::Formatter) -> fmt::Result {
        fmt.write_str("string")
    }
    fn visit_str<E>(self, value: &str) -> Result<Variant_, E>
    where
        E: de::Error,
    {
        let v = match value {
            "createSimpleWebhookDetails" => Variant_::CreateSimpleWebhookDetails,
            "createOpsgenieIntegrationDetails" => {
                Variant_::CreateOpsgenieIntegrationDetails
            }
            "createTeamsWebhookIntegrationDetails" => {
                Variant_::CreateTeamsWebhookIntegrationDetails
            }
            "createPagerDutyIntegrationDetails" => {
                Variant_::CreatePagerDutyIntegrationDetails
            }
            value => Variant_::Unknown(value.to_string().into_boxed_str()),
        };
        Ok(v)
    }
}
///An unknown variant of the CreateIntegrationDetails union.
#[derive(Debug, Clone, PartialEq, Eq, PartialOrd, Ord, Hash)]
pub struct Unknown {
    type_: Box<str>,
    value: conjure_object::Any,
}
impl Unknown {
    /// Returns the unknown variant's type name.
    #[inline]
    pub fn type_(&self) -> &str {
        &self.type_
    }
}
